Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Functionnal_unit/Operation/src/Operation.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Functionnal_unit/Operation/src/Operation.cpp	(revision 98)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Functionnal_unit/Operation/src/Operation.cpp	(revision 100)
@@ -255,9 +255,9 @@
     // Result
     op->_timing       = param->_timing[op->_type][op->_operation];
-    op->_data_rd      = imm;
+    op->_data_rd      = imm<<2; // add "00"
   //op->_data_re      = 0;
     op->_exception    = EXCEPTION_ALU_NONE;
     op->_no_sequence  = 1;
-    op->_address      = gpr;
+    op->_address      = gpr>>2; // del "00"
   };
 
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Functionnal_unit/SelfTest/src/test.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Functionnal_unit/SelfTest/src/test.cpp	(revision 98)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Functionnal_unit/SelfTest/src/test.cpp	(revision 100)
@@ -279,7 +279,7 @@
 							     			       
   							     			       
-  transaction_in.push_back(execute_transaction(_param,0,0,0, 31,OPERATION_BRANCH_L_JALR    ,TYPE_BRANCH,0,0xdeadbeef,0x0       ,0x12345678,0              ,0,63,0xdeadbeef,0,15,FLAG_CY        ,EXCEPTION_NONE     ,1,0x12345678)); // jr
-  transaction_in.push_back(execute_transaction(_param,0,0,0, 32,OPERATION_BRANCH_L_JALR    ,TYPE_BRANCH,1,0xdeadbeef,0x0       ,0x12345678,0              ,1,63,0xdeadbeef,0,15,FLAG_CY        ,EXCEPTION_NONE     ,1,0x12345678)); // jal
-  transaction_in.push_back(execute_transaction(_param,0,0,0, 33,OPERATION_BRANCH_L_JALR    ,TYPE_BRANCH,1,0xdeadbeef,0x0       ,0x12345678,0              ,1,63,0xdeadbeef,0,15,FLAG_CY        ,EXCEPTION_NONE     ,1,0x12345678)); // jalr
+  transaction_in.push_back(execute_transaction(_param,0,0,0, 31,OPERATION_BRANCH_L_JALR    ,TYPE_BRANCH,0,0xdeadbeef,0x0       ,0x12345678,0              ,0,63,0xdeadbeef,0,15,FLAG_CY        ,EXCEPTION_NONE     ,1,0x12345678>>2)); // jr
+  transaction_in.push_back(execute_transaction(_param,0,0,0, 32,OPERATION_BRANCH_L_JALR    ,TYPE_BRANCH,1,0xdeadbeef,0x0       ,0x12345678,0              ,1,63,0xdeadbeef<<2,0,15,FLAG_CY        ,EXCEPTION_NONE     ,1,0x12345678>>2)); // jal
+  transaction_in.push_back(execute_transaction(_param,0,0,0, 33,OPERATION_BRANCH_L_JALR    ,TYPE_BRANCH,1,0xdeadbeef,0x0       ,0x12345678,0              ,1,63,0xdeadbeef<<2,0,15,FLAG_CY        ,EXCEPTION_NONE     ,1,0x12345678>>2)); // jalr
 							     
   transaction_in.push_back(execute_transaction(_param,0,0,0, 34,OPERATION_EXTEND_L_EXTEND_S,TYPE_EXTEND,1,8         ,0x12345678,0x0       ,0              ,1,63,0x00000078,0,15,FLAG_CY        ,EXCEPTION_NONE     ,0));
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Functionnal_unit/src/Functionnal_unit_transition.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Functionnal_unit/src/Functionnal_unit_transition.cpp	(revision 98)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Functionnal_unit/src/Functionnal_unit_transition.cpp	(revision 100)
@@ -138,5 +138,5 @@
             log_printf(TRACE,Functionnal_unit,FUNCTION,"    * exception     : %d"  ,_execute_operation_in->_exception  );
             log_printf(TRACE,Functionnal_unit,FUNCTION,"    * no_sequence   : %d"  ,_execute_operation_in->_no_sequence);
-            log_printf(TRACE,Functionnal_unit,FUNCTION,"    * address       : %.8x",_execute_operation_in->_address    );
+            log_printf(TRACE,Functionnal_unit,FUNCTION,"    * address       : %.8x (%.8x)",_execute_operation_in->_address,_execute_operation_in->_address<<2);
 
 #ifdef STATISTICS
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Read_queue/src/Read_queue_vhdl.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Read_queue/src/Read_queue_vhdl.cpp	(revision 98)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Read_queue/src/Read_queue_vhdl.cpp	(revision 100)
@@ -32,5 +32,6 @@
     param_queue = new morpheo::behavioural::generic::queue::Parameters
       (_param->_size_queue,
-       _param->_size_internal_queue
+       _param->_size_internal_queue,
+       0
        );
     
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Write_unit/Write_unit/Execute_queue/src/Execute_queue_vhdl.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Write_unit/Write_unit/Execute_queue/src/Execute_queue_vhdl.cpp	(revision 98)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Write_unit/Write_unit/Execute_queue/src/Execute_queue_vhdl.cpp	(revision 100)
@@ -34,5 +34,6 @@
     param_queue = new morpheo::behavioural::generic::queue::Parameters
       (_param->_size_queue,
-       _param->_size_internal_queue
+       _param->_size_internal_queue,
+       0
        );
     
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Decod_unit/Decod/Instruction/src/Instruction.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Decod_unit/Decod/Instruction/src/Instruction.cpp	(revision 98)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Decod_unit/Decod/Instruction/src/Instruction.cpp	(revision 100)
@@ -903,6 +903,6 @@
     inst->_type               = instruction_information(INSTRUCTION_L_JALR)._type     ; //TYPE_BRANCH;
     inst->_operation          = instruction_information(INSTRUCTION_L_JALR)._operation; //OPERATION_BRANCH_L_JALR;
-    inst->_has_immediat       = 0;
-    inst->_immediat           = 0; // unnecessary
+    inst->_has_immediat       = 1;
+    inst->_immediat           = inst->_address_next+1;
     inst->_read_ra            = 0;
     inst->_num_reg_ra         = 0; //unnecessary
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Prediction_unit_Glue/SelfTest/config_mono_context.cfg
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Prediction_unit_Glue/SelfTest/config_mono_context.cfg	(revision 98)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Prediction_unit_Glue/SelfTest/config_mono_context.cfg	(revision 100)
@@ -3,5 +3,5 @@
 1	1	*4	# nb_decod_unit      
 30	30	+32	# size_address       
-1	1	*4	# nb_instruction  [0] [nb_context]
+1	4	*2	# nb_instruction  [0] [nb_context]
 1	1	*4	# size_depth      [0] [nb_context]
 4	4	*4	# nb_inst_decod   [0] [nb_decod_unit]
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Prediction_unit_Glue/SelfTest/src/test.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Prediction_unit_Glue/SelfTest/src/test.cpp	(revision 98)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Prediction_unit_Glue/SelfTest/src/test.cpp	(revision 100)
@@ -362,4 +362,8 @@
 
   // Initialisation
+  const bool test1 = false;
+  const bool test2 = true ;
+  const bool test3 = false;
+  const bool test4 = false;
 
   const uint32_t seed = 0;
@@ -402,4 +406,5 @@
       LABEL("Iteration %d",iteration);
 
+      if (test1)
       {
 	LABEL("Test sequential");
@@ -481,4 +486,5 @@
       }
 
+      if (test2)
       {
       	LABEL("Test no sequential - L.J");
@@ -489,11 +495,13 @@
 	for (uint32_t i=0; i<_param->_nb_instruction [context]; i++)
 	  {
-	    Taddress_t addr      = (1<<(_param->_nb_instruction[context]+4));
-	    Taddress_t addr_src  = addr+i;
+	    Taddress_t pc_current  = (1<<(_param->_nb_instruction[context]+3));
+            Taddress_t pc_previous = pc_current-1;
+	    Taddress_t addr_src  = pc_current+i;
 	    Taddress_t addr_dest = 0xdeadbeef;
-	    
-	    in_PREDICT_PC_PREVIOUS           [context]->write(0);
-	    in_PREDICT_PC_CURRENT            [context]->write(addr);
-	    in_PREDICT_PC_CURRENT_IS_DS_TAKE [context]->write(0);
+	    Tcontrol_t is_ds_take= rand()%2;
+
+	    in_PREDICT_PC_PREVIOUS           [context]->write(pc_previous);
+	    in_PREDICT_PC_CURRENT            [context]->write(pc_current);
+	    in_PREDICT_PC_CURRENT_IS_DS_TAKE [context]->write(is_ds_take);
 
 	    bool find = false;
@@ -515,5 +523,5 @@
 		    LABEL(" * BTB address : 0x%x",out_PREDICT_BTB_ADDRESS    [port]->read());
 		    if ((out_PREDICT_BTB_CONTEXT_ID [port]->read() == context) and
-			(out_PREDICT_BTB_ADDRESS    [port]->read() == addr   ))
+			(out_PREDICT_BTB_ADDRESS    [port]->read() == (is_ds_take)?pc_previous:pc_current   ))
 		      {
 			in_PREDICT_BTB_ACK          [port]->write((rand()%100)<percent_transaction_predict);
@@ -531,27 +539,42 @@
 		SC_START(0);
 
+                LABEL ("PREDICT_VAL : %d", in_PREDICT_VAL[context]->read());
+                LABEL ("PREDICT_ACK : %d",out_PREDICT_ACK[context]->read());
+                
 		if (in_PREDICT_VAL[context]->read() and out_PREDICT_ACK[context]->read())
 		  {
 		    LABEL ("PREDICT         [%d] - Transaction accepted",context);
+		    LABEL ("  * pc_previous: 0x%x",pc_previous );
+		    LABEL ("  * pc_current : 0x%x",pc_current      );
+		    LABEL ("  * addr_src   : 0x%x",addr_src  );
+		    LABEL ("  * addr_dest  : 0x%x",addr_dest );
+		    LABEL ("  * is_ds_take : %d"  ,is_ds_take);
+
 		    find = true;
-
-		    TEST(Taddress_t        ,out_PREDICT_PC_NEXT                     [context]->read(),addr_dest);
-		    TEST(Tcontrol_t        ,out_PREDICT_PC_NEXT_IS_DS_TAKE          [context]->read(),i==(_param->_nb_instruction [context]-1));
+                    
+                    Tcontrol_t next_is_ds_take = (not is_ds_take and (i==(_param->_nb_instruction [context]-1)));
+
+                    TEST(Tcontrol_t        ,out_PREDICT_PC_NEXT_IS_DS_TAKE          [context]->read(), next_is_ds_take);
+		    TEST(Taddress_t        ,out_PREDICT_PC_NEXT                     [context]->read(),(next_is_ds_take)?(addr_src+1):addr_dest);
 		    TEST(Tinst_ifetch_ptr_t,out_PREDICT_INST_IFETCH_PTR             [context]->read(),i);
-		    TEST(Tbranch_state_t   ,out_PREDICT_BRANCH_STATE                [context]->read(),BRANCH_STATE_NSPEC_TAKE);
+                    TEST(Tbranch_state_t   ,out_PREDICT_BRANCH_STATE                [context]->read(),(next_is_ds_take)?BRANCH_STATE_NONE:BRANCH_STATE_NSPEC_TAKE);
 // 		    TEST(Tprediction_ptr_t ,out_PREDICT_BRANCH_UPDATE_PREDICTION_ID [context]->read(),0);
 
-		    uint32_t k=((addr_src%_param->_nb_instruction[context])==_param->_nb_instruction[context]-1)?_param->_nb_instruction[context]:((addr_src%_param->_nb_instruction[context])+2);
+		    uint32_t k=((is_ds_take)?1:((next_is_ds_take)?_param->_nb_instruction[context]:((addr_src%_param->_nb_instruction [context])+2)));
+
+
+// ((addr_src%_param->_nb_instruction[context])==_param->_nb_instruction[context]-1)?_param->_nb_instruction[context]:((addr_src%_param->_nb_instruction[context])+2);
+
 		    LABEL("instruction enable : ");
 		    LABEL("  [0:%d[ = 1",k);
-		    LABEL("  [%d:%d[ = 1",k,_param->_nb_instruction[context]);
+		    LABEL("  [%d:%d[ = 0",k,_param->_nb_instruction[context]);
 		    for (uint32_t j=0; j<k; j++)
-		      TEST(Tcontrol_t        ,out_PREDICT_INSTRUCTION_ENABLE [context][j]->read(),1);
+		    TEST(Tcontrol_t        ,out_PREDICT_INSTRUCTION_ENABLE [context][j]->read(),1);
 		    for (uint32_t j=k; j<_param->_nb_instruction[context]; j++)
-		      TEST(Tcontrol_t        ,out_PREDICT_INSTRUCTION_ENABLE [context][j]->read(),0);
+		    TEST(Tcontrol_t        ,out_PREDICT_INSTRUCTION_ENABLE [context][j]->read(),0);
 
 		    TEST(Tcontrol_t        ,out_PREDICT_BTB_VAL        [port]->read(),1); 
 		    TEST(Tcontext_t        ,out_PREDICT_BTB_CONTEXT_ID [port]->read(),context);
-		    TEST(Taddress_t        ,out_PREDICT_BTB_ADDRESS    [port]->read(),addr);
+		    TEST(Taddress_t        ,out_PREDICT_BTB_ADDRESS    [port]->read(),(is_ds_take)?pc_previous:pc_current);
 		  }
 		
@@ -571,5 +594,6 @@
 	  }
       }
-
+      
+      if (test3)
       {
 	LABEL("Decod - Ok");
@@ -618,4 +642,5 @@
       }
 
+      if (test4)
       {
 	LABEL("Decod - Ko");
